# date4/conversion.rb: Written by Tadayoshi Funaba 1998-2006
# $Id: conversion.rb,v 1.4 2006-12-30 21:49:56+09 tadf Exp $

class Time

  unless defined? to_time
    def to_time() getlocal end
  end

  def to_date4
    jd = Date4.__send__(:civil_to_jd, year, mon, mday, Date4::ITALY)
    Date4.new!([jd, 0], 0, Date4::ITALY)
  end

  def to_datetime4
    jd = DateTime4.__send__(:civil_to_jd, year, mon, mday, DateTime4::ITALY)
    fr = DateTime4.__send__(:time_to_day_fraction, hour, min, [sec, 59].min) +
	 usec.to_r/86400_000_000
    of = utc_offset.to_r/86400
    DateTime4.new!([jd, fr], of, DateTime4::ITALY)
  end

end

class Date4

  def to_time() Time.local(year, mon, mday) end
  def to_date4() self end
  def to_datetime4() DateTime4.new!([jd, 0], @of, @sg) end

  def self.today(sg=ITALY) Time.now.to_date4    .new_start(sg) end
  def self.now  (sg=ITALY) Time.now.to_datetime4.new_start(sg) end

  private_class_method :now

end

class DateTime4 < Date4

  def to_time
    d = new_offset(0)
    d.instance_eval do
      Time.utc(year, mon, mday, hour, min, sec,
	       (sec_fraction * 1_000_000).to_i)
    end.
	getlocal
  end

  def to_date4() Date4.new!([jd, 0], 0, @sg) end
  def to_datetime4() self end

  private_class_method :today
  public_class_method  :now

end
