# date4/format/parse.rb: Written by Tadayoshi Funaba 1999-2007
# $Id: parse.rb,v 1.12 2007-05-19 09:24:06+09 tadf Exp $

class Date4

  def self.s3e(e, y, m, d, bc=false)
    unless String === m
      m = m.to_s
    end

    if y == nil
      if d && d.size > 2
	y = d
	d = nil
      end
      if d && d[0,1] == "'"
	y = d
	d = nil
      end
    end

    if y
      y.scan(/(\d+)(.+)?/)
      if $2
	y, d = d, $1
      end
    end

    if m
      if m[0,1] == "'" || m.size > 2
	y, m, d = m, d, y # us -> be
      end
    end

    if d
      if d[0,1] == "'" || d.size > 2
	y, d = d, y
      end
    end

    if y
      y =~ /([-+])?(\d+)/
      if $1 || $2.size > 2
	c = false
      end
      iy = $&.to_i
      if bc
	iy = -iy + 1
      end
      e.year = iy
    end

    if m
      m =~ /\d+/
      e.mon = $&.to_i
    end

    if d
      d =~ /\d+/
      e.mday = $&.to_i
    end

    if c != nil
      e._comp = c
    end

  end

  private_class_method :s3e

  def self._parse_day(str, e)
    if str.sub!(/\b(#{e._lc.abbr_days.keys.join('|')})[^-\d\s]*/in, ' ')
      e.wday = e._lc.abbr_days[$1.downcase]
      true
=begin
    elsif str.sub!(/\b(?!\dth)(su|mo|tu|we|th|fr|sa)\b/in, ' ')
      e.wday = %w(su mo tu we th fr sa).index($1.downcase)
      true
=end
    end
  end

  def self._parse_time(str, e)
    if str.sub!(
		/(
		   (?:
		     \d+\s*:\s*\d+
		     (?:
		       \s*:\s*\d+(?:[,.]\d*)?
		     )?
		   |
		     \d+\s*h(?:\s*\d+m?(?:\s*\d+s?)?)?
		   )
		   (?:
		     \s*
		     [ap](?:m\b|\.m\.)
		   )?
		 |
		   \d+\s*[ap](?:m\b|\.m\.)
		 )
		 (?:
		   \s*
		   (
		     (?:gmt|utc?)?[-+]\d+(?:[,.:]\d+(?::\d+)?)?
		   |
		     [a-z.\s]+(?:standard|daylight)\stime\b
		   |
		     [a-z]+(?:\sdst)?\b
		   )
		 )?
		/inx,
		' ')

      t = $1
      e.zone = $2 if $2

      t =~ /\A(\d+)h?
	      (?:\s*:?\s*(\d+)m?
		(?:
		  \s*:?\s*(\d+)(?:[,.](\d+))?s?
		)?
	      )?
	    (?:\s*([ap])(?:m\b|\.m\.))?/inx

      e.hour = $1.to_i
      e.min = $2.to_i if $2
      e.sec = $3.to_i if $3
      e.sec_fraction = $4.to_i.to_r / (10**$4.size) if $4

      if $5
	e.hour %= 12
	if $5.downcase == 'p'
	  e.hour += 12
	end
      end
      true
    end
  end

=begin
  def self._parse_beat(str, e)
    if str.sub!(/@\s*(\d+)(?:[,.](\d*))?/, ' ')
      beat = $1.to_i.to_r
      beat += $2.to_i.to_r / (10**$2.size) if $2
      secs = beat.to_r / 1000
      h, min, s, fr = self.day_fraction_to_time(secs)
      e.hour = h
      e.min = min
      e.sec = s
      e.sec_fraction = fr * 86400
      e.zone = '+01:00'
      true
    end
  end
=end

  def self._parse_eu(str, e)
    if str.sub!(
		/'?(\d+)[^-\d\s]*
		 \s*
		 (#{e._lc.abbr_months.keys.join('|')})[^-\d\s']*
		 (?:
		   \s*
		   (c(?:e|\.e\.)|b(?:ce|\.c\.e\.)|a(?:d|\.d\.)|b(?:c|\.c\.))?
		   \s*
		   ('?-?\d+(?:(?:st|nd|rd|th)\b)?)
		 )?
		/inx,
		' ') # '
      s3e(e, $4, e._lc.abbr_months[$2.downcase], $1,
	  $3 && $3[0,1].downcase == 'b')
      true
    end
  end

  def self._parse_us(str, e)
    if str.sub!(
		/\b(#{e._lc.abbr_months.keys.join('|')})[^-\d\s']*
		 \s*
		 ('?\d+)[^-\d\s']*
		 (?:
		   \s*
		   (c(?:e|\.e\.)|b(?:ce|\.c\.e\.)|a(?:d|\.d\.)|b(?:c|\.c\.))?
		   \s*
		   ('?-?\d+)
		 )?
		/inx,
		' ') # '
      s3e(e, $4, e._lc.abbr_months[$1.downcase], $2,
	  $3 && $3[0,1].downcase == 'b')
      true
    end
  end

  def self._parse_iso(str, e)
    if str.sub!(/('?[-+]?\d+)-(\d+)-('?-?\d+)/n, ' ')
      s3e(e, $1, $2, $3)
      true
    end
  end

  def self._parse_iso2(str, e)
    if str.sub!(/\b(\d{2}|\d{4})?-?w(\d{2})(?:-?(\d))?\b/in, ' ')
      e.cwyear = $1.to_i if $1
      e.cweek = $2.to_i
      e.cwday = $3.to_i if $3
      true
    elsif str.sub!(/-w-(\d)\b/in, ' ')
      e.cwday = $1.to_i 
      true
    elsif str.sub!(/--(\d{2})?-(\d{2})\b/n, ' ')
      e.mon = $1.to_i if $1
      e.mday = $2.to_i
      true
    elsif str.sub!(/--(\d{2})(\d{2})?\b/n, ' ')
      e.mon = $1.to_i
      e.mday = $2.to_i if $2
      true
    elsif str.sub!(/-(\d{3})\b/n, ' ')
      e.yday = $1.to_i
      true
    end
  end

  def self._parse_jis(str, e)
    if str.sub!(/\b([MTSH])(\d+)\.(\d+)\.(\d+)/in, ' ')
      era = { 'm'=>1867,
	      't'=>1911,
	      's'=>1925,
	      'h'=>1988
	  }[$1.downcase]
      e.year = $2.to_i + era
      e.mon = $3.to_i
      e.mday = $4.to_i
      true
    end
  end

  def self._parse_vms(str, e)
    if str.sub!(/('?-?\d+)-(#{e._lc.abbr_months.keys.join('|')})[^-]*
		-('?-?\d+)/inx, ' ')
      s3e(e, $3, e._lc.abbr_months[$2.downcase], $1)
      true
    elsif str.sub!(/\b(#{e._lc.abbr_months.keys.join('|')})[^-]*
		-('?-?\d+)(?:-('?-?\d+))?/inx, ' ')
      s3e(e, $3, e._lc.abbr_months[$1.downcase], $2)
      true
    end
  end

  def self._parse_sla_ja(str, e)
    if str.sub!(%r|('?-?\d+)/\s*('?\d+)(?:[^\d]\s*('?-?\d+))?|n, ' ') # '
      s3e(e, $1, $2, $3)
      true
    end
  end

  def self._parse_sla_eu(str, e)
    if str.sub!(%r|('?-?\d+)/\s*('?\d+)(?:[^\d]\s*('?-?\d+))?|n, ' ') # '
      s3e(e, $3, $2, $1)
      true
    end
  end

  def self._parse_sla_us(str, e)
    if str.sub!(%r|('?-?\d+)/\s*('?\d+)(?:[^\d]\s*('?-?\d+))?|n, ' ') # '
      s3e(e, $3, $1, $2)
      true
    end
  end

  def self._parse_dot_ja(str, e)
    if str.sub!(%r|('?-?\d+)\.\s*('?\d+)\.\s*('?-?\d+)|n, ' ') # '
      s3e(e, $1, $2, $3)
      true
    end
  end

  def self._parse_dot_eu(str, e)
    if str.sub!(%r|('?-?\d+)\.\s*('?\d+)\.\s*('?-?\d+)|n, ' ') # '
      s3e(e, $3, $2, $1)
      true
    end
  end

  def self._parse_dot_us(str, e)
    if str.sub!(%r|('?-?\d+)\.\s*('?\d+)\.\s*('?-?\d+)|n, ' ') # '
      s3e(e, $3, $1, $2)
      true
    end
  end

  def self._parse_year(str, e)
    if str.sub!(/'(\d+)\b/in, ' ')
      e.year = $1.to_i
      true
    end
  end

  def self._parse_mon(str, e)
    if str.sub!(/\b(#{e._lc.abbr_months.keys.join('|')})\S*/in, ' ')
      e.mon = e._lc.abbr_months[$1.downcase]
      true
    end
  end

  def self._parse_mday(str, e)
    if str.sub!(/(\d+)(st|nd|rd|th)\b/in, ' ')
      e.mday = $1.to_i
      true
    end
  end

  def self._parse_ddd(str, e)
    if str.sub!(
		/([-+]?)(\d{2,14})
		  (?:
		    \s*
		    T?
		    \s*
		    (\d{2,6})?(?:[,.](\d*))?
		  )?
		  (?:
		    \s*
		    (
		      Z\b
		    |
		      [-+]\d{1,4}\b
		    |
		      \[[-+]?\d[^\]]*\]
		    )
		  )?
		/inx,
		' ')
      case $2.size
      when 2
	if $3.nil? && $4
	  e.sec  = $2[-2, 2].to_i
	else
	  e.mday = $2[ 0, 2].to_i
	end
      when 4
	if $3.nil? && $4
	  e.sec  = $2[-2, 2].to_i
	  e.min  = $2[-4, 2].to_i
	else
	  e.mon  = $2[ 0, 2].to_i
	  e.mday = $2[ 2, 2].to_i
	end
      when 6
	if $3.nil? && $4
	  e.sec  = $2[-2, 2].to_i
	  e.min  = $2[-4, 2].to_i
	  e.hour = $2[-6, 2].to_i
	else
	  e.year = ($1 + $2[ 0, 2]).to_i
	  e.mon  = $2[ 2, 2].to_i
	  e.mday = $2[ 4, 2].to_i
	end
      when 8, 10, 12, 14
	if $3.nil? && $4
	  e.sec  = $2[-2, 2].to_i
	  e.min  = $2[-4, 2].to_i
	  e.hour = $2[-6, 2].to_i
	  e.mday = $2[-8, 2].to_i
	  if $2.size >= 10
	    e.mon  = $2[-10, 2].to_i
	  end
	  if $2.size == 12
	    e.year = ($1 + $2[-12, 2]).to_i
	  end
	  if $2.size == 14
	    e.year = ($1 + $2[-14, 4]).to_i
	    e._comp = false
	  end
	else
	  e.year = ($1 + $2[ 0, 4]).to_i
	  e.mon  = $2[ 4, 2].to_i
	  e.mday = $2[ 6, 2].to_i
	  e.hour = $2[ 8, 2].to_i if $2.size >= 10
	  e.min  = $2[10, 2].to_i if $2.size >= 12
	  e.sec  = $2[12, 2].to_i if $2.size >= 14
	  e._comp = false
	end
      when 3
	if $3.nil? && $4
	  e.sec  = $2[-2, 2].to_i
	  e.min  = $2[-3, 1].to_i
	else
	  e.yday = $2[ 0, 3].to_i
	end
      when 5
	if $3.nil? && $4
	  e.sec  = $2[-2, 2].to_i
	  e.min  = $2[-4, 2].to_i
	  e.hour = $2[-5, 1].to_i
	else
	  e.year = ($1 + $2[ 0, 2]).to_i
	  e.yday = $2[ 2, 3].to_i
	end
      when 7
	if $3.nil? && $4
	  e.sec  = $2[-2, 2].to_i
	  e.min  = $2[-4, 2].to_i
	  e.hour = $2[-6, 2].to_i
	  e.mday = $2[-7, 1].to_i
	else
	  e.year = ($1 + $2[ 0, 4]).to_i
	  e.yday = $2[ 4, 3].to_i
	end
      end
      if $3
	if $4
	  case $3.size
	  when 2, 4, 6
	    e.sec  = $3[-2, 2].to_i
	    e.min  = $3[-4, 2].to_i if $3.size >= 4
	    e.hour = $3[-6, 2].to_i if $3.size >= 6
	  end
	else
	  case $3.size
	  when 2, 4, 6
	    e.hour = $3[ 0, 2].to_i
	    e.min  = $3[ 2, 2].to_i if $3.size >= 4
	    e.sec  = $3[ 4, 2].to_i if $3.size >= 6
	  end
	end
      end
      if $4
	e.sec_fraction = $4.to_i.to_r / (10**$4.size)
      end
      if $5
	e.zone = $5
	if e.zone[0,1] == '['
	  o, n, = e.zone[1..-2].split(':')
	  e.zone = n || o
	  if /\A\d/ =~ o
	    o = format('+%s', o)
	  end
	  e.offset = zone_to_diff(o)
	end
      end
      true
    end
  end

  def self._parse_k_hi(str, e)
    if str.sub!(/(\265\252\270\265\301\260|\271\304\265\252|\300\276\316\361|\314\300\274\243|\302\347\300\265|\276\274\317\302|\312\277\300\256|\271\304|\300\276|\314\300|\302\347|\276\274|\312\277)?\s*
		 (?:(\270\265|\d+)\s*\307\257\s*)?
		 (?:(\d+)\s*\267\356\s*)
		 (?:(\d+)\s*\306\374\s*)
		/nx, ' ') ||
       str.sub!(/(\265\252\270\265\301\260|\271\304\265\252|\300\276\316\361|\314\300\274\243|\302\347\300\265|\276\274\317\302|\312\277\300\256|\271\304|\300\276|\314\300|\302\347|\276\274|\312\277)\s*
			  (?:(\270\265|\d+))
		 (?:\s*[-\/.]+\s*(\d+)
		 (?:\s*[-\/.]+\s*(\d+))?)?
		/nx, ' ')

      era = { "\271\304\265\252" => -660,
	      "\300\276\316\361" =>    0,
	      "\314\300\274\243" => 1867,
	      "\302\347\300\265" => 1911,
	      "\276\274\317\302" => 1925,
	      "\312\277\300\256" => 1988,
	      "\271\304"   => -660,
	      "\300\276"   =>    0,
	      "\314\300"   => 1867,
	      "\302\347"   => 1911,
	      "\276\274"   => 1925,
	      "\312\277"   => 1988
	  }[$1]
      if $2
	e.year = ($2.to_i.nonzero? || 1)
	e.year += era if era
      end
      if $1 && $2
	if $1 == "\265\252\270\265\301\260"
	  e.year = -e.year + 1
	end
      end
      e.mon = $3.to_i if $3
      e.mday = $4.to_i if $4
    end
  end

  def self._parse_k_ji(str, e)
    if str.sub!(/(?:(?:\270\341)?(\301\260|\270\345)|\277\274(?:\314\353)?)?\s*
		 (?:(\d+)\s*(?:\273\376)\s*)
		 (?:(\d+)\s*(?:\312\254)\s*)?
		 (?:(\d+)(?:[.,](\d*))?\s*(?:\311\303))?
		 (?i:
		   \s*
		   (
		     (?:gmt|utc?)?[-+]\d+(?:[,.:]\d+(?::\d+)?)?
		   |
		     [a-z.\s]+(?:standard|daylight)\stime\b
		   |
		     [a-z]+(?:\sdst)?\b
		   )
		 )?
		/nx, ' ') ||
       str.sub!(/(?:(?:\270\341)?(\301\260|\270\345)|\277\274(?:\314\353)?)\s*
			    (\d+)
		 (?:\s*:+\s*(\d+)
		 (?:\s*:+\s*(\d+)(?:[.,](\d*))?)?)?
		 (?i:
		   \s*
		   (
		     (?:gmt|utc?)?[-+]\d+(?:[,.:]\d+(?::\d+)?)?
		   |
		     [a-z.\s]+(?:standard|daylight)\stime\b
		   |
		     [a-z]+(?:\sdst)?\b
		   )
		 )?
		/nx, ' ')

      e.hour = $2.to_i if $2
      e.min = $3.to_i if $3
      e.sec = $4.to_i if $4
      if $5
	e.sec_fraction = $5.to_i.to_r / (10**$5.size)
      end

      if $1 && $2
	e.hour %= 12
	if $1 == "\270\345"
	  e.hour += 12
	end
      end

      if $6
	e.zone = $6
      end
    end
  end

  def self._parse_k_yo(str, e)
    if str.sub!(/(\306\374|\267\356|\262\320|\277\345|\314\332|\266\342|\305\332)[^-\d\s]*/n, ' ')
      wday = { "\306\374" => 0,
	       "\267\356" => 1,
	       "\262\320" => 2,
	       "\277\345" => 3,
	       "\314\332" => 4,
	       "\266\342" => 5,
	       "\305\332" => 6
      }[$1]
      e.wday = wday
    end
  end

  private_class_method :_parse_day, :_parse_time, # :_parse_beat,
	:_parse_eu, :_parse_us, :_parse_iso, :_parse_iso2,
	:_parse_jis, :_parse_vms,
	:_parse_sla_ja, :_parse_sla_eu, :_parse_sla_us,
	:_parse_dot_ja, :_parse_dot_eu, :_parse_dot_us,
	:_parse_year, :_parse_mon, :_parse_mday, :_parse_ddd,
	:_parse_k_hi, :_parse_k_ji, :_parse_k_yo

  def self._parse(*args)
    str, comp, lc, = parsearg([[nil, :d, :date],
			       [false, :comp, :complete],
			       [Format::Locale::C, :lc, :locale]], args)
    str = str.dup

    e = Format::Bag.new

    e._comp = comp
    e._lc = lc

    require 'nkf'

    ostr = str
    str = NKF.nkf('-e', str)

    str.gsub!(/[^-+',.\/:0-9@a-z\[\]\x80-\xff]+/in, ' ')

    _parse_k_hi(str, e)
    _parse_k_ji(str, e)
    _parse_k_yo(str, e)

    if e.to_hash.empty?
      str = ostr
      str.gsub!(/[^-+',.\/:0-9@a-z\[\]\x80-\xff]+/in, ' ')
    end

    case lc.style
    when 'ja'
      _parse_time(str, e) # || _parse_beat(str, e)
      _parse_eu(str, e)     ||
      _parse_us(str, e)     ||
      _parse_iso(str, e)    ||
      _parse_jis(str, e)    ||
      _parse_vms(str, e)    ||
      _parse_sla_ja(str, e) ||
      _parse_dot_ja(str, e) ||
      _parse_iso2(str, e)   ||
      _parse_year(str, e)   ||
      _parse_mon(str, e)    ||
      _parse_mday(str, e)   ||
      _parse_ddd(str, e)
      _parse_day(str, e)
    when 'eu'
      _parse_time(str, e) # || _parse_beat(str, e)
      _parse_eu(str, e)     ||
      _parse_iso(str, e)    ||
      _parse_jis(str, e)    ||
      _parse_vms(str, e)    ||
      _parse_sla_eu(str, e) ||
      _parse_dot_eu(str, e) ||
      _parse_iso2(str, e)   ||
      _parse_year(str, e)   ||
      _parse_mon(str, e)    ||
      _parse_mday(str, e)   ||
      _parse_ddd(str, e)    ||
      _parse_us(str, e)
      _parse_day(str, e)
    when 'us'
      _parse_time(str, e) # || _parse_beat(str, e)
      _parse_eu(str, e)     ||
      _parse_us(str, e)     ||
      _parse_iso(str, e)    ||
      _parse_jis(str, e)    ||
      _parse_vms(str, e)    ||
      _parse_sla_us(str, e) ||
      _parse_dot_us(str, e) ||
      _parse_iso2(str, e)   ||
      _parse_year(str, e)   ||
      _parse_mon(str, e)    ||
      _parse_mday(str, e)   ||
      _parse_ddd(str, e)
      _parse_day(str, e)
    else
      _parse_time(str, e) # || _parse_beat(str, e)
      _parse_eu(str, e)     ||
      _parse_us(str, e)     ||
      _parse_iso(str, e)    ||
      _parse_jis(str, e)    ||
      _parse_vms(str, e)    ||
      _parse_sla_us(str, e) ||
      _parse_dot_ja(str, e) ||
      _parse_iso2(str, e)   ||
      _parse_year(str, e)   ||
      _parse_mon(str, e)    ||
      _parse_mday(str, e)   ||
      _parse_ddd(str, e)
      _parse_day(str, e)
    end

    if str.sub!(/\b(bc\b|bce\b|b\.c\.|b\.c\.e\.)/in, ' ')
      if e.year
	e.year = -e.year + 1
      end
    end

    if str.sub!(/\A\s*(\d{1,2})\s*\z/n, ' ')
      if e.hour && !e.mday
	v = $1.to_i
	if (1..31) === v
	  e.mday = v
	end
      end
      if e.mday && !e.hour
	v = $1.to_i
	if (0..24) === v
	  e.hour = v
	end
      end
    end

    if e._comp && e.year
      if e.year >= 0 && e.year <= 99
	if e.year >= 69
	  e.year += 1900
	else
	  e.year += 2000
	end
      end
    end

    e.offset ||= zone_to_diff(e.zone) if e.zone

    e.to_hash
  end

  module Base

    private

    def zone_to_diff(zone)
      zone = zone.downcase
      if zone.sub!(/\s+(standard|daylight)\s+time\z/, '')
	dst = $1 == 'daylight'
      else
	dst = zone.sub!(/\s+dst\z/, '')
      end
      if Format::ZONES.include?(zone)
	offset = Format::ZONES[zone]
	offset += 3600 if dst
      elsif zone.sub!(/\A(?:gmt|utc?)?([-+])/, '')
	sign = $1
	if zone.include?(':')
	  hour, min, sec, = zone.split(':')
	elsif zone.include?(',') || zone.include?('.')
	  hour, fr, = zone.split(/[,.]/)
	  min = fr.to_i.to_r / (10**fr.size) * 60
	else
	  case zone.size
	  when 3
	    hour = zone[0,1]
	    min = zone[1,2]
	  else
	    hour = zone[0,2]
	    min = zone[2,2]
	    sec = zone[4,2]
	  end
	end
	offset = hour.to_i * 3600 + min.to_i * 60 + sec.to_i
	offset *= -1 if sign == '-'
      end
      offset
    end

  end

  extend  Base
  include Base
  remove_const :Base

end
