# date4/timezone/tzinfo.rb: Written by Tadayoshi Funaba 2006
# $Id: tzinfo.rb,v 1.2 2006-12-30 21:50:28+09 tadf Exp $

require 'tzinfo' # Philip Ross's

class Date4

  module TimeZone

    class TZInfo

      def initialize(path) @tzinfo = ::TZInfo::Timezone.get(path) end

      def lookup(ajd, adj)
	dt = DateTime. # should be the original DateTime
	  __send__(if DateTime.respond_to?(:new!)
		   then :new! else :new0 end, ajd)
	period = if adj
		 then @tzinfo.period_for_local(dt)
		 else @tzinfo.period_for_utc(dt) end
	zone = period.zone_identifier.to_s
	offset = period.utc_total_offset_rational
	dst = period.dst?
	{:zone=>zone, :of=>offset, :utc=>false, :dst=>dst}
      end

      def inspect() format('#<%s: %s>', self.class, @tzinfo.inspect) end
      def to_s() @tzinfo.to_s end

    end

  end

end
